<?php

function resize_img($max_x, $max_y, $file, $suffix)
{
            $gdimg = imagecreatefromjpeg($file.'.jpg');
            $x = imagesx($gdimg);
            $y = imagesy($gdimg);
            $orig_ratio = ($x / $y);
            $need_ratio = ($max_x/$max_y);

            if ($need_ratio < $orig_ratio) {
                //$save = imagecreatetruecolor($x/($x/$max_x), $y/($x/$max_x));
                $save = imagecreatetruecolor($max_y/($y/$x), $max_y);
                imagecopyresized($save, $gdimg, 0, 0, 0, 0, $max_y/($y/$x), $max_y, $x, $y);
            }
            else {
                //$save = imagecreatetruecolor($x/($y/$max_y), $y/($y/$max_y));
                $save = imagecreatetruecolor($max_x, $max_x/($x/$y));
                imagecopyresized($save, $gdimg, 0, 0, 0, 0, $max_x, $max_x/($x/$y), $x, $y);
            }
            //imagecopyresized($save, $gdimg, 0, 0, 0, 0, $max_x, $max_y, $x, $y);
            $new_img = imagecreatetruecolor($max_x, $max_y);
            imagecopy($new_img, $save, 0, 0, 0, 0, $max_x, $max_y);
            $result = imagejpeg($new_img, $file.$suffix.'.jpg',85);
            return $result;
}

function divide_into_pages($table, $where_arr = array(), $count_on_page = 10, $current_page = '1')
{
    $field_arr = array(
                 0 => array('field_name' => 'COUNT(*) AS rows'));
    $rows = get_obj_list($table, $field_arr, $where_arr);
    $rows = $rows[0]['rows'];
    $page_count = 0;
    $page_count = floor($rows / $count_on_page);
    if (floor($rows / $count_on_page) < ($rows / $count_on_page))
        $page_count += 1;
    $pages = array();
    for ($i = 1; $i <= ($page_count); $i++) {
        $ii = ''.$i;
        if ($current_page == $ii)
            $pages[$ii] = array('ul' => ($i-1)*$count_on_page, 'cur' => 1);
        else
            $pages[$ii] = array('ul' => ($i-1)*$count_on_page, 'cur' => 0);
    };

    return $pages;
}

function return_variable_from_request($variable,$def_value = "not default value")
{
    if (isset($_POST[$variable]) or isset($_GET[$variable]))  {
        if (isset($_POST[$variable]))  {
            $var_temp=$_POST[$variable];
        } elseif (isset($_GET[$variable])) {
            $var_temp=$_GET[$variable];
        };
    };
    if (!empty($var_temp))  {
        global $$variable;
        $$variable=$var_temp;
        return true;
    } else {
        if ($def_value != "not default value") {
            global $$variable;
            $$variable=$def_value;
            return true;
        };
        return false;
    };
}

function display_renderer_form($form, $tpl)
{
    global $smarty;

    // Create the renderer object
    $renderer =& new HTML_QuickForm_Renderer_ArraySmarty($Smarty);

    // set custom error message
    $renderer->setRequiredTemplate('{if $error} <span class="error">{$span}</span> {else} <span class="required">{$span}</span>{/if}');
    $renderer->setErrorTemplate('{if $error} <span class="error">{$span}</span>{/if}{$html}');

    // build the HTML for the form
    $form->accept($renderer);

    // assign title to page
    $smarty->assign('title', $title);

    // assign array with form data
    $smarty->assign('form_data', $renderer->toArray());

    // parse and display the template
    //$smarty->display('admin/edit_'.$table.'.html');
    $smarty->display('admin/'.$tpl.'.html');

}

function edit_obj($action, $obj_id, $table, $field_arr, $hidden_arr, $additional_group_arr = array())
{
    global $smarty;
    global $image_path;
    global $product_image_dir;
    global $location_image_dir;


    $title = $action." ".$table;

    $form = new HTML_QuickForm('frm'.$action.$table, 'post', 'edit.php');

    // adding basic form elements
    for ($i = 0; $i <= (count($field_arr)-1); $i++) {
        if ($field_arr[$i]['visible'] == 1)
            if ($field_arr[$i]['type'] == "file") {
                $image = $form->addElement('file', $field_arr[$i]['name'], 'Photo:', 'class="file"');
                $img_field[] = $image;
            } else {
                $info[$i] = $form->createElement($field_arr[$i]['type'], $field_arr[$i]['name'], $field_arr[$i]['caption']);
            };
    };

    $form->addGroup($info, $table.'Info', $table.' info', null, false);

    // adding additional elements form
    /*for ($i = 0; $i <= (count($additional_group_arr)-1); $i++) {
        unset($info);
        for ($ii = 0; $ii <= (count($additional_group_arr[$i]['data'])-1); $ii++) {
            if ($additional_group_arr[$i]['data'][$ii]['visible'] == 1)
                $info[$i] = $form->createElement($additional_group_arr[$i]['data'][$ii]['type'], $additional_group_arr[$i]['data'][$ii]['name'], $additional_group_arr[$i]['data'][$ii]['caption']);
        };
        $form->addGroup($info, $additional_group_arr[$i]['name'], $additional_group_arr[$i]['caption'], null, false);
    }; */

    for ($i = 0; $i <= (count($hidden_arr)-1); $i++) {
        $form->addElement('hidden', $hidden_arr[$i]['name'], $hidden_arr[$i]['value']);
    };

    if ($action != "add") {
        $obj_info = get_obj_by_id($table, $field_arr, $obj_id);
        for ($i = 0; $i <= (count($field_arr)-1); $i++)
            if ($field_arr[$i]['visible'] == 1)
                $defaults_arr[$field_arr[$i]['name']] = $obj_info[0][$field_arr[$i]['field_name']];
    } else
        for ($i = 0; $i <= (count($field_arr)-1); $i++)
            $defaults_arr[$field_arr[$i]['name']] = "";

    $form->setDefaults($defaults_arr);

    if(!$form->isSubmitted()) {
        if (isset($img_field))
            $image_group = $form->addGroup($img_field, $table.'Photo', $table.' photo', null, false);
        $form->addElement('submit', 'btnSubmit', $action, 'class="button"');
    }

    if ($form->isSubmitted() && $form->validate()) {
        $form->freeze();
        switch ($action){
        case 'edit':
            $res = obj_update($table, $field_arr, $form->exportValues());
        break;
        case 'add':
            $res = obj_insert($table, $field_arr, $form->exportValues());
        break;
        case 'delete':
            $res = obj_delete($table, $field_arr, $form->exportValues());
            if (file_exists($image_path.$product_image_dir.$res.'.jpg'))
                 unlink($image_path.$product_image_dir.substr($table, 0, 3).$res.'.jpg');
        break;
        default:
            die("Don't use this function!!!");
        break; };

        $res_upload = true;
        if (isset($image))
            if ($image->isUploadedFile() && is_int($res))
                $res_upload = $image->moveUploadedFile($image_path.$product_image_dir, substr($table, 0, 3).$res.'.jpg');

        if ($res_upload && is_int($res)) {
            switch ($action){
            case 'edit':
                $smarty->assign('message', $table.' '.$action.'ed!');
            break;
            case 'add':
                $smarty->assign('message', $table.' '.$action.'ed!');
            break;
            case 'delete':
                $smarty->assign('message', $table.' '.$action.'d!');
            break; };
        } elseif (is_int($res)) {
            $smarty->assign('message', $table.' info saved, but image not uploaded');
        } else {
            $smarty->assign('messageType', 'error');
            $smarty->assign('message', "error: $res");
        }
    } else {
        if ($action == "delete") {
            $form->freeze();
        };
    };

    display_renderer_form($form, "edit");

    return $res;

}

function list_obj($table, $field_arr, $item_arr = array(), $where_arr = array(), $order_by_arr = array(), $add_to_id = False, $add_to_table = False)
{
    global $smarty;

    $title = $table." list";
    $list=get_obj_list($table, $field_arr, $where_arr, $order_by_arr);

    // assign current table to page
    $smarty->assign('table', $table);

    // assign title to page
    $smarty->assign('title', $title);

    // assign array with data
    $smarty->assign('list_data', $list);

    // assign array with item data
    $smarty->assign('list_item_data', $item_arr);

    // assign id to add new items
    $smarty->assign('add_to_id', $add_to_id);

    // assign level up table
    $smarty->assign('up_table', $add_to_table);

    // parse and display the template
    $smarty->display('admin/list.html');

    return true;

}

function get_meta($slug) {
  $field_arr = array(
    0 => array('field_name' => 'slug'),
    1 => array('field_name' => 'id'),
    2 => array('field_name' => 'title'),
    3 => array('field_name' => 'description'),
    4 => array('field_name' => 'keywords'),
    5 => array('field_name' => 'content'),
    6 => array('field_name' => 'parent'),
  );

  $where_arr = array(
      0 => array('field_name' => 'slug', 'value' => "'$slug'"),
  );

  $pages_meta = get_obj_list("pages_meta", $field_arr, $where_arr);

  return $pages_meta[0];
}

function get_meta_list_by_parent($slug) {
  $field_arr = array(
    0 => array('field_name' => 'slug'),
    1 => array('field_name' => 'id'),
    2 => array('field_name' => 'title'),
    3 => array('field_name' => 'description'),
    4 => array('field_name' => 'keywords'),
    5 => array('field_name' => 'content'),
    6 => array('field_name' => 'parent'),
  );

  $where_arr = array(
      0 => array('field_name' => 'slug', 'value' => "'$slug'"),
  );

  $pages_meta = get_obj_list("pages_meta", $field_arr, $where_arr);

  $where_arr = array(
      0 => array('field_name' => 'parent', 'value' => $pages_meta[0]['id']),
  );

  $childs = get_obj_list("pages_meta", $field_arr, $where_arr);

  return $childs;
}

?>
