<?php

$cur_mod = 'product';

function get_product_by_id($id) {
    if (!isset($id))
        return "Not selected product!";
    global $cur_mod;
    $query =    'SELECT product.name, product.description, product.isSpecOffer as isSpecOffer, '.
                'product.price, '.
                'product.location AS location_id, '.
                'locations.name AS product_location '.
                'FROM product, locations '.
                'WHERE locations.id=product.location '.
                'AND product.id='.$id.' '.
                'ORDER BY product.pub_date LIMIT 1';
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r->data[0];
}

function get_account_info($username, $password) {
    global $cur_mod;
    $query="SELECT id,username,password,firstname,secondname,email,phone,last_vasit ".
           "FROM account ".
           "WHERE username='$username' AND password='$password'";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r -> data;
}

function get_product_list_for_account($user_id) {
    global $cur_mod;
    $query="SELECT COUNT(*) AS a_to_p_count FROM account_to_product WHERE account='$user_id'";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    $a_to_p_count = $r -> data;
    $a_to_p_count = $a_to_p_count[0]['a_to_p_count'];

    $query="SELECT product.id AS product_id, product.name AS product_name,product.description AS product_description, product.pub_date AS product_pub_date, product.price AS product_price, product.general_picture AS product_general_picture,locations.name AS product_location, state.description AS state_description, state.milestone AS state_milestone, product.isSpecOffer as isSpecOffer ".
           "FROM account_to_product,product,location,state ".
           "WHERE account_to_product.account='$user_id' AND product.id=account_to_product.product AND locations.id=product.location ORDER BY state.pub_date_time DESC LIMIT $a_to_p_count";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r -> data;
}

function get_actual_list_state($product_id, $state_pub_date_time_actual) {
    global $cur_mod;
    $query="SELECT product.id AS product_id, state.pub_date_time AS state_pub_date_time, state.description AS state_description, state.milestone AS state_milestone ".
           "FROM product,state ".
           "WHERE product.id='$product_id' AND state.product=product.id AND state.pub_date_time>='$state_pub_date_time_actual' ORDER BY state.pub_date_time DESC";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r -> data;
}

function get_full_list_state($product_id, $state_pub_date_time_actual) {
    global $cur_mod;
    $query="SELECT product.id AS product_id, state.pub_date_time AS state_pub_date_time, state.description AS state_description, state.milestone AS state_milestone ".
           "FROM product,state ".
           "WHERE product.id='$product_id' AND state.product=product.id ORDER BY state.pub_date_time DESC";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r -> data;
}

function get_picture($product_id) {
    global $cur_mod;
    $query="SELECT id AS picture_id, name AS picture_name, path AS picture_path ".
           "FROM picture ".
           "WHERE picture.product='$product_id'";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r -> data;
}

function get_property_values_for_product($product_id) {
    global $cur_mod;
    $query='SELECT property_value.value AS property_value, '.
            'property.id AS property_id, property.name AS property_name, '.
            'property.description AS property_description, '.
            'property_value.id AS property_value_id '.
            'FROM property_value, property '.
            "WHERE property_value.product='$product_id' AND (property.id=property_value.property OR property_value.property = 0) ".
            'ORDER BY property_value.id';
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r->data;
}

function search_product_by_price($product_price_min, $product_price_max) {
    global $cur_mod;
    if ($product_price_min>$product_price_max) {
        $product_price_temp=$product_price_min;
        $product_price_min=$product_price_max;
        $product_price_max=$product_price_temp;
    };
    $query="SELECT product.id AS product_id, product.name AS product_name, product.price AS product_price, locations.name AS product_location_name ".
           "FROM product, location ".
           "WHERE product.price>='$product_price_min' AND product.price<='$product_price_max' AND locations.id=product.location";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r -> data;
}

function search_product_by_location($location_id) {
    global $cur_mod;
    $query='SELECT product.id AS product_id, '.
            'product.name AS product_name, '.
            'product.description AS product_description, '.
            'product.price AS product_price, '.
            'locations.name AS product_location '.
            'FROM product, locations '.
            "WHERE product.location='$location_id' ".
            'AND product.location=locations.id ';
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r->data;
}

function list_product_with_special_offer() {
    global $cur_mod;
    $query='SELECT product.id AS product_id, '.
        'product.name AS product_name, '.
        'product.price AS product_price, '.
        'picture.id AS product_general_picture, '.
        'picture.name AS product_general_pic_alt '.
        'FROM product, picture '.
        "WHERE product.isSpecOffer=1 AND product.id=picture.product AND picture.is_main=1 LIMIT 3";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r->data;
}

function get_list_related_for_product($product_id) {
    global $cur_mod;
    $query="SELECT product.id AS product_id, product.name AS product_name ".
           "FROM product_related, product ".
           "WHERE product_related.product_id='$product_id' AND product.id=product_related.related_id";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    return $r -> data;
}

function product_insert($data) {
    global $cur_mod;

    $query = "INSERT INTO `product` (`name`, `description`, `price`, `location`, `pub_date`, `isSpecOffer`) ".
                "VALUES ('".addslashes($data['prodName'])."', '".addslashes($data['prodDescr'])."', '".$data['prodPrice'].
                "', '".$data['prodLoc']."', NOW(), '".$data['prodTop']."')";

    $r = dbmod_query($cur_mod, $query, __FILE__, __LINE__);
    if ($r->info['error']) {
        return $r->info['error'];
    }
    else {
        $product_id = $r->info['ins_id'];
    }

    $props = get_obj_list("property", array(0 => array("field_name" => "id"),1 => array("field_name" => "name")));
    //foreach($data['prodProp'] as $prop => $val) {
    foreach ($props as $row) {
        $i = $row['id'];
        if((!empty($data['prodPropVal'.$i])) and $data['prodProp'.$i]) {
            $prop_query = 'INSERT INTO `property_value` (`product`, `property`, `value`) '.
            "VALUES ('".$product_id."', '".$data['prodProp'.$i]."', '".addslashes($data['prodPropVal'.$i])."')";
            $r = dbmod_query($cur_mod, $prop_query, __FILE__, __LINE__);
            if ($r->info['error']) { return $r->info['error']; }
        }
    }
    return $product_id;
}

function product_update($data) {
    global $cur_mod;

    $query = 'UPDATE `product` SET '.
                "`name`='".addslashes($data['prodName'])."', ".
                "`description`='".addslashes($data['prodDescr'])."', ".
                "`price`='".$data['prodPrice']."', ".
                "`location`='".$data['prodLoc']."', ".
                "`isSpecOffer`='".$data['prodTop']."' ".
                "WHERE id=".$data['id'].' LIMIT 1';
    $r = dbmod_query($cur_mod, $query, __FILE__, __LINE__);

    if ($r->info['error'])
        return $r->info['error'];

    $query='SELECT property_value.id AS property_value_id '.
            'FROM property_value, property '.
            'WHERE property_value.product='.$data['id'].' AND (property.id=property_value.property OR property_value.property = 0)'.
            'ORDER BY property_value.id';

    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );

    if ($r->info['error'])
        return $r->info['error'];

    if ($r->data[0]['property_value_id']) {
     foreach($r->data as $prop) {
         echo $data['prodProp'.$prop['property_value_id']];
         if ($data['prodProp'.$prop['property_value_id']] != 0) {
             $query = 'UPDATE property_value SET '.
                        "`value`='".addslashes($data['prodPropVal'.$prop['property_value_id']])."', ".
                        "`property`=".$data['prodProp'.$prop['property_value_id']]." ".
                        'WHERE id='.$prop['property_value_id'];
             $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
             if ($r->info['error'])
                 return $r->info['error'];
         }
         else {
             $query = 'DELETE FROM `property_value` WHERE id='.$prop['property_value_id'];
             $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
             if ($r->info['error'])
                 return $r->info['error'];
         }
     }
    }
    else {
     for($i=0;$i<4;$i++) {
        if(!empty($data['prodPropVal'.$i])) {
            $prop_query = 'INSERT INTO `property_value` (`product`, `property`, `value`) '.
            "VALUES ('".$data['id']."', '".$data['prodProp'.$i]."', '".addslashes($data['prodPropVal'.$i])."')";
            $r = dbmod_query($cur_mod, $prop_query, __FILE__, __LINE__);
            if ($r->info['error']) { return $r->info['error']; }
        }
     }
    }

    if ($data['addNewProp']) {
        echo $data['addNewProp'];
        for($i=0; $i<$data['addNewProp']; $i++) {
                $prop_query = 'INSERT INTO `property_value` (`product`, `property`, `value`) '.
                    "VALUES ('".$data['id']."', '".$data['prodNewProp'.$i]."', '".addslashes($data['prodNewPropVal'.$i])."')";
                $r = dbmod_query($cur_mod, $prop_query, __FILE__, __LINE__);
                if ($r->info['error']) { return $r->info['error']; }
        }
    }

    return (int) $data['id'];

}

function account_to_product_insert($post) {
    global $cur_mod;

    if (!isset($post['product'])) {
        $err="Not selected Product!";
        return $err;
    } else {
        $query="SELECT id AS product_id FROM product WHERE id='".intval($post['product'])."'";
        $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
        if ($r->rows <= 0) {
            $err="Not selected Product!";
            return $err;
        }
    };
    if (!isset($post['account'])) {
        $err="Not selected Account!";
        return $err;
    } else {
        $query="SELECT id AS account_id FROM account WHERE id='".intval($post['account'])."'";
        $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
        if ($r->rows <= 0) {
            $err="Not selected Account!";
            return $err;
        }
    };

    $query="SELECT id AS account_to_product_id FROM account_to_product WHERE account='".intval($post['account'])."' AND product='".intval($post['product'])."'";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    if ($r->rows > 0) {
        $err="Don't duplicate rows from account_to_product!";
        return $err;
    };

    $query = 'INSERT INTO `account_to_product` '.
             '(`account`, `product`) '.
             'VALUES '."(".intval($post['account']).", ".intval($post['product']).")";
    $r = dbmod_query($cur_mod, $query, __FILE__, __LINE__);
    $err = $r->info['error'];
    return $err;
}

function product_delete($id) {
    global $cur_mod;
    global $image_path;
    global $product_image_dir;

    if (!is_int($id))
        return "Bogus id!";

    $query = 'DELETE FROM `product` '.
             'WHERE id= '.$id.' LIMIT 1';
    $r = dbmod_query($cur_mod, $query, __FILE__, __LINE__);
    if ($r->info['error']) { return $r->info['error']; }
    // remove image
    //if (is_file($image_path.$product_image_dir, $res.'.jpg'))
    //    unlink($image_path.$product_image_dir, $res.'.jpg');

    else {
        $prop_query = 'DELETE FROM `property_value` '.
                        'WHERE product='.$id;
        $r = dbmod_query($cur_mod, $prop_query, __FILE__, __LINE__);

        $pic_query = 'SELECT id FROM `picture` WHERE product='.$id;
        $pictures = dbmod_query($cur_mod, $pic_query, __FILE__, __LINE__);
        foreach ($pictures->data as $pict) {
            foreach (glob($image_path.$product_image_dir.'pic'.$pict['id'].'*') as $file)
                unlink($file);
        }

        $prop_query = 'DELETE FROM `picture` '.
                        'WHERE product='.$id;
        $r = dbmod_query($cur_mod, $prop_query, __FILE__, __LINE__);
        if ($r->info['error']) { return $r->info['error']; }
        else { return false; }
    }
}

function set_related_for_product($product_id, $prod_related) {
    global $cur_mod;

    if (!is_int($product_id))
        return "Bogus id!";

    $query = 'DELETE FROM `product_related` '.
        'WHERE `product_id`='.$product_id;

    $r = dbmod_query($cur_mod, $query, __FILE__, __LINE__);
    if ($r->info['error']) { return $r->info['error']; }

    foreach ($prod_related as $item) {
      if ($item) { // don't write empty values
        $query = 'INSERT INTO `product_related` (`product_id`, `related_id`) VALUES '.
                    "($product_id, $item)";
        $r = dbmod_query($cur_mod, $query, __FILE__, __LINE__);
        if ($r->info['error']) { return $r->info['error']; }
      }
    }
    return True;
}

function get_obj_by_id($table, $field_arr, $obj_id) {
    global $cur_mod;

    $obj=intval($obj_id);

    $query="SELECT id";
    for ($i = 0; $i <= (count($field_arr)-1); $i++) {
        $query .= ", ";
        $query .= $field_arr[$i]['field_name'];
    };
    $query .= " FROM $table ";
    $query .= "WHERE id=$obj_id";

    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    $obj = $r -> data;
    if ($r->info['error']) { return false; }
    else { return $obj; }
}


function obj_update($table, $field_arr, $data) {
    global $cur_mod;

    if (!isset($data['id']))
        return "Not selected category!";

    $id = intval($data['id']);

    for ($i = 0; $i <= (count($field_arr)-1); $i++) {
        if ((!isset($data[$field_arr[$i]['name']])) and ($field_arr[$i]['type'] == "checkbox"))
            $data[$field_arr[$i]['name']] = 0;
        if ((!isset($data[$field_arr[$i]['name']])) and ($field_arr[$i]['type'] != "file"))
        if ($field_arr[$i]['visible'] == 1) {
            $err="Field '".$field_arr[$i]['caption']."' is empty!";
            return $err;
        }
    }

    $query = 'UPDATE `'.$table.'` SET ';

    for ($i = 0; $i <= (count($field_arr)-1); $i++) {
        $query .= "`".$field_arr[$i]['field_name']."`='".addslashes($data[$field_arr[$i]['name']])."'";
        if ($i < (count($field_arr)-1))
            $query .= ", ";
    };
    $query .= " WHERE id=".$id.' LIMIT 1';

    $r = dbmod_query($cur_mod, $query, __FILE__, __LINE__);
    if ($r->info['error'])
        return $r->info['error'];

    return (int) $data['id'];

}


function obj_insert($table, $field_arr, $data) {
    global $cur_mod;

    for ($i = 0; $i <= (count($field_arr)-1); $i++) {
        if (($field_arr[$i]['visible'] == 1) and ($field_arr[$i]['type'] != "file")) {
            if ((!isset($data[$field_arr[$i]['name']])) and ($field_arr[$i]['type'] == "checkbox"))
                $data[$field_arr[$i]['name']] = 0;
            if (!isset($data[$field_arr[$i]['name']])) {
                $err="Field '".$field_arr[$i]['caption']."' is empty!";
                return $err;
            }
        }
    }

    $query = 'INSERT INTO `'.$table.'` (';

    for ($i = 0; $i <= (count($field_arr)-1); $i++) {
        $query .= $field_arr[$i]['field_name'];
        if ($i < (count($field_arr)-1))
            $query .= ", ";
    };
    $query .= ') VALUES (';

    for ($i = 0; $i <= (count($field_arr)-1); $i++) {
        if ($field_arr[$i]['visible'] == 1) {
            $query .= "'".addslashes($data[$field_arr[$i]['name']])."'";
        } elseif ($field_arr[$i]['visible'] == 0) {
            $query .= "'".addslashes($field_arr[$i]['caption'])."'";
        } else {
            $query .= addslashes($field_arr[$i]['caption']);
        };
        if ($i < (count($field_arr)-1))
            $query .= ", ";
    };
    $query .= ')';

    $r = dbmod_query($cur_mod, $query, __FILE__, __LINE__);
    if ($r->info['error'])
        return $r->info['error'];

    $ii = -1;
    for ($i = 0; $i <= (count($field_arr)-1); $i++) {
        if ($field_arr[$i]['visible'] == 1) {
            $ii = $ii + 1;
            $where_arr[$ii]["field_name"] = $field_arr[$i]['field_name'];
            $where_arr[$ii]["value"] = "'".addslashes($data[$field_arr[$i]['name']])."'";
        } elseif ($field_arr[$i]['visible'] == 0) {
            $ii = $ii + 1;
            $where_arr[$ii]["field_name"] = $field_arr[$i]['field_name'];
            $where_arr[$ii]["value"] = "'".addslashes($field_arr[$i]['caption'])."'";
        };
    };

    $r = get_obj_list($table, array(0 => array('visible' =>0, 'field_name' => 'id')), $where_arr);

    $data['id'] = $r[0]['id'];
    for ($i = 0; $i <= (count($field_arr)-1); $i++)
        if ($field_arr[$i]['type'] == "file") {
            $data[$field_arr[$i]["name"]] = substr($table, 0, 3).$data['id'].'.jpg';
            obj_update($table, array( 0 => $field_arr[$i]), $data);
        };

    return (int) $data['id'];

}

function obj_delete($table, $field_arr, $data) {
    global $cur_mod;

    if (!isset($data['id']))
        return "Not selected category!";

    $id = intval($data['id']);

    $query = 'DELETE FROM `'.$table.'` ';
    $query .= "WHERE id=".$id.' LIMIT 1';

    $r = dbmod_query($cur_mod, $query, __FILE__, __LINE__);
    if ($r->info['error'])
        return $r->info['error'];

    return (int) $data['id'];

}

function get_obj_list($table, $field_arr, $where_arr = array(), $order_by_arr = array(), $limit = 0, $limit_c = 0) {
    global $cur_mod;

    $query = "SELECT ";

    for ($i = 0; $i <= (count($field_arr)-1); $i++) {
        $query .= $field_arr[$i]['field_name'];
        if ($i < (count($field_arr)-1))
            $query .= ", ";
    };

    $query .= " FROM ".$table;

    if ((count($where_arr)) > 0)
        $query .= " WHERE ";
    for ($i = 0; $i <= (count($where_arr)-1); $i++) {
        if (isset($where_arr[$i]['lte']))
            $query .= $where_arr[$i]['field_name']."<=".$where_arr[$i]['lte']."";
        elseif (isset($where_arr[$i]['gte']))
            $query .= $where_arr[$i]['field_name'].">=".$where_arr[$i]['gte']."";
        else
            $query .= $where_arr[$i]['field_name']."=".$where_arr[$i]['value']."";
        if ($i < (count($where_arr)-1))
            $query .= " AND ";
    };

    if ((count($order_by_arr)) > 0)
        $query .= " ORDER BY ";
    for ($i = 0; $i <= (count($order_by_arr)-1); $i++) {
        $query .= $order_by_arr[$i]['field_name']." ".$order_by_arr[$i]['value'];
        if ($i < (count($order_by_arr)-1))
            $query .= ", ";
    };

    $limit_temp = $limit;
    $limit = $limit_c;
    if (($limit > 0)) {
        $query .= " LIMIT ".intval($limit_temp).",".intval($limit);
    } else {
        $limit = $limit_temp;
        if (($limit > 0))
            $query .= " LIMIT ".intval($limit);
    };

    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    $list = $r -> data;
    if ($r->info['error']) { return $r->info['error']; }
    else { return $list; }
}

function get_list_product() { //GaNs...
    global $cur_mod;
    $query="SELECT ".
            "product.name AS product_name, product.id AS product_id, ".
            "product.description AS product_description, ".
            "product.pub_date AS product_pub_date, product.price AS product_price, ".
            "product.general_picture AS product_general_picture, ".
            "product.isSpecOffer as isSpecOffer, ".
            "locations.name AS product_location ".
            "FROM product,locations ".
            "WHERE locations.id=product.location ORDER BY product.pub_date";
    $r = dbmod_query( $cur_mod, $query, __FILE__, __LINE__ );
    $list = $r -> data;
    return $list;
}

?>
